Subject: Re: [PATCHv2 5/6] gitweb: last-modified time should be commiter, not author

From: Jakub Narebski <[email-masked]>
Date: Thu, 12 Feb 2009 10:07:28 +0100

On Wed, 11 Feb 2009, Giuseppe Bilotta wrote:
> On Wed, Feb 11, 2009 at 10:18 AM, Jakub Narebski <[email-masked]> wrote:
>> On Wed, 11 Feb 2009, Giuseppe Bilotta wrote:
>>> On Wed, Feb 11, 2009 at 4:10 AM, Deskin Miller <[email-masked]> wrote:
>>>>
>>>> git reflog?
>>>>
>>>> Seems like one could find the oldest time the commit appears in the
>>>> reflog, for the branch one is interested in.  You can use the commit
>>>> time to limit the search through the reflog, but there would be clock
>>>> skew concerns.
>>>
>>> Bingo! Thanks a lot
>>>
>>> oblomov@rbot ~ $ GIT_DIR=/var/git/rbot.git/ git reflog show
>>> --since="two days ago" master | cat
>>> 7324b32... master@{0}: push
>>> e2dc08d... master@{1}: push
>>> oblomov@rbot ~ $ GIT_DIR=/var/git/rbot.git/ git reflog show
>>> --since="yesterday" master | cat
>>> oblomov@rbot ~ $
>>>
>>> I'll try to work it in the next review for this patchset.
>>
>> Assuming that you have reflog enabled (yes, it is default now)...
>> So you would have to provide fallback in the case there is no reflog.
>>
>> BTW. "git reflog" is porcelain; it would be better to parse reflog
>> directly, I think.
> 
> Does disabling reflog remove old reflogs? IOW, can I check if reflog
> is enabled just by opening the reflog file and assuming reflog isn't
> enabled if it's not there? Falling back to the commit date would still
> work decently.

You can disable reflog by setting core.logAllRefUpdates to false...
which of course do not remove reflog.  But checking for this config
variable in gitweb shouldn't be too hard, although you would need
to somehow change assumption that we are interested only in ^gitweb\.
section of config.

There is other side of this issue: reflog is expired, so you can
have empty reflog if branch was updated long time ago.

>
> Since we're only interested in the last reflog date, what we can do is
> to read the last line and get the unix time which is held two places
> before the tab separating the metadata from the log message. Correct?

Almost correct.  Some tools (old StGit for example) didn't provide
reflog message, and with empty message they forgot to append TAB
separator.  So you would have to provide for legacy

  <old sha-1> <new-sha-1> <committer> <timestamp> <timezone>

instead of correct (for empty reflog message)

  <old sha-1> <new-sha-1> <committer> <timestamp> <timezone> TAB

P.S. It is a pity that due to packed refs stat-ing branch tip file
$GIT_DIR/refs/heads/<branch> is not enough...
-- 
Jakub Narebski
Poland